import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PolyhedronData {
    Vector[] V=new Vector[10];
    int[][] facet=new int[10][10];
    int length;

    public PolyhedronData() {}

    public static Vector pointA(double[] a) {
	double aa=Math.sqrt(1/a[0]-1);
	double bb=Math.sqrt(1/a[1]-1);
	Vector V=new Vector(0,0,aa);
	return(V);
    }

    public static Vector pointB(double[] a) {
	Vector V=new Vector(0,0,0);
	return(V);
    }

    public static Vector pointC(double[] a) {	
        double aa=Math.sqrt(1/a[0]-1);
	double bb=Math.sqrt(1/a[1]-1);
	Vector V=new Vector(aa*bb,0,0);
	return(V);
    }

    public static Vector pointD(double[] a) {	
        double aa=Math.sqrt(1/a[0]-1);
	double bb=Math.sqrt(1/a[1]-1);
	Vector V=new Vector(aa*bb,bb,0);
	return(V);
    }

    public static Vector pointE(double[] a) {
        double aa=Math.sqrt(1/a[0]-1);
	double bb=Math.sqrt(1/a[1]-1);
	double cc=Math.sqrt(1/a[2]-1);
	double t=(aa*cc)/Math.sqrt(aa*aa*bb*bb+bb*bb);
	Vector V=new Vector(t*aa*bb,t*bb,0);
	return(V);
    }

    public static Vector pointF(double[] a) {
        double aa=Math.sqrt(1/a[0]-1);
	double bb=Math.sqrt(1/a[1]-1);
	double cc=Math.sqrt(1/a[2]-1);
	double t=Math.sqrt(aa*aa*cc*cc+cc*cc);
	Vector V=new Vector(t,0,0);	
        return(V);
    }

    public static Vector pointG(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointF(a);
	Vector V=new Vector(.5*V1.x[0]+.5*V2.x[0],.5*V1.x[1]+.5*V2.x[1],0);	
        return(V);
    }

    public static double squareDistance(int i,int j,double[] a) {
	Vector V1=pointX(i,a);
	Vector V2=pointX(j,a);
	double d=Vector.dist2(V1,V2);
	return(d);
    }

    public static Vector pointH(double[] a) {
	Vector V1=pointG(a);
	double t1=squareDistance(1,6,a)+squareDistance(0,1,a)-squareDistance(2,6,a);
	double t2=2*Math.sqrt(squareDistance(0,1,a));
	double z=t1/t2;
	V1.x[2]=z;
	return(V1);
    }

    public static Vector pointI(double[] a) {
	Vector V=pointH(a);
	V.x[1]=0;
	return(V);
    }

    public static Vector pointJ(double[] a) {
	Vector V=pointH(a);
	Vector W1=pointD(a);
	Vector W2=new Vector(W1.x[1],-W1.x[0],0);
	V=W2.proj(V);
	return(V);
    }

    public static Vector pointK(double[] a) {
	Vector V=pointA(a);
	Vector W=pointH(a);
	Vector X=new Vector();
	for(int i=0;i<3;++i) X.x[i]=2*W.x[i]-V.x[i];
	return(X);
    }

    public static Vector pointL(double[] a) {
	Vector V=pointA(a);
	Vector W=pointI(a);
	Vector X=new Vector();
	for(int i=0;i<3;++i) X.x[i]=2*W.x[i]-V.x[i];
	return(X);
    }

    public static Vector pointM(double[] a) {
	Vector V=pointA(a);
	Vector W=pointJ(a);
	Vector X=new Vector();
	for(int i=0;i<3;++i) X.x[i]=2*W.x[i]-V.x[i];
	return(X);
    }



    public static Vector pointN(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointM(a);
	Vector V3=pointE(a);
	Vector V4=pointJ(a);
	return(Vector.specialCross(V1,V2,V3,V4,V2));
    }

    public static Vector pointO(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointM(a);
	Vector V3=pointE(a);
	Vector V4=pointJ(a);
	Vector V5=pointK(a);
	return(Vector.specialCross(V1,V2,V3,V4,V5));
    }

    public static Vector pointP(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointJ(a);
	Vector V3=pointA(a);
	Vector V4=pointE(a);
	return(Vector.specialCross(V1,V2,V3,V4,V2));
    }

    public static Vector pointQ(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointM(a);
	Vector V3=pointA(a);
	Vector V4=pointE(a);
	return(Vector.specialCross(V1,V2,V3,V4,V2));
    }

    public static Vector pointR(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointM(a);
	Vector V3=pointA(a);
	Vector V4=pointE(a);
	Vector V5=pointK(a);
	return(Vector.specialCross(V1,V2,V3,V4,V5));
    }

    public static Vector pointS(double[] a) {
	Vector V1=pointD(a);
	Vector V2=pointJ(a);
	Vector V3=pointA(a);
	Vector V4=pointE(a);
	Vector V5=pointH(a);
	return(Vector.specialCross(V1,V2,V3,V4,V5));
    }

  


    public static Vector pointDM(double[] a) {
	Vector V=pointD(a);
	Vector W=pointM(a);
	Vector X=Vector.average(V,W);
	return(X);
    }


    public static Vector pointX(int i,double[] a) {
	if(i==0) return(pointA(a));
	if(i==1) return(pointB(a));
	if(i==2) return(pointC(a));
	if(i==3) return(pointD(a));
	if(i==4) return(pointE(a));
	if(i==5) return(pointF(a));
	if(i==6) return(pointG(a));
	if(i==7) return(pointH(a));
	if(i==8) return(pointI(a));
	if(i==9) return(pointJ(a));
	if(i==10) return(pointK(a));
	if(i==11) return(pointL(a));
	if(i==12) return(pointM(a));
	if(i==13) return(pointN(a));
	if(i==14) return(pointO(a));
	if(i==15) return(pointP(a));
	if(i==16) return(pointQ(a));
	if(i==17) return(pointR(a));
	if(i==18) return(pointS(a));
	return(new Vector(0,0,0));
    }

    public static int[][] tetraFacets() {
	int[][] f=new int[10][10];
	f[0][0]=4;

	f[1][0]=3;
	f[1][1]=1;
	f[1][2]=2;
	f[1][3]=3;

	f[2][0]=3;
	f[2][1]=0;
	f[2][2]=2;
	f[2][3]=1;

	f[3][0]=3;
	f[3][1]=0;
	f[3][2]=3;
	f[3][3]=2;

	f[4][0]=3;
	f[4][1]=0;
	f[4][2]=1;
	f[4][3]=3;
	return(f);
    }

    public static int[][] prismFacets() {
	int[][] f=new int[10][10];
	f[0][0]=5;

	f[1][0]=3;
	f[1][1]=0;
	f[1][2]=2;
	f[1][3]=1;

	f[2][0]=3;
	f[2][1]=0;
	f[2][2]=3;
	f[2][3]=2;

	f[3][0]=3;
	f[3][1]=0;
	f[3][2]=4;
	f[3][3]=3;

	f[4][0]=3;
	f[4][1]=0;
	f[4][2]=1;
	f[4][3]=4;

	f[5][0]=4;
	f[5][1]=1;
	f[5][2]=2;
	f[5][3]=3;
	f[5][4]=4;
	return(f);
    }

    public static int[][] specialFacets() {
	int[][] f=new int[10][10];
	f[0][0]=6;

	f[1][0]=3;
	f[1][1]=1;
	f[1][2]=2;
	f[1][3]=3;

	f[2][0]=4;
	f[2][1]=0;
	f[2][2]=1;
	f[2][3]=3;
	f[2][4]=5;

	f[3][0]=4;
	f[3][1]=2;
	f[3][2]=3;
	f[3][3]=4;
	f[3][4]=6;

	f[4][0]=3;
	f[4][1]=3;
	f[4][2]=4;
	f[4][3]=5;

	f[5][0]=3;
	f[5][1]=4;
	f[5][2]=5;
	f[5][3]=6;

	f[6][0]=4;
	f[6][1]=0;
	f[6][2]=1;
	f[6][3]=2;
	f[6][4]=6;

	f[7][0]=3;
	f[7][1]=0;
	f[7][2]=5;
	f[7][3]=6;

	return(f);
    }


    public static int[][] wedgeFacets() {
	int[][] f=new int[10][10];
	f[0][0]=5;

	f[1][0]=4;
	f[1][1]=5;
	f[1][2]=4;
	f[1][3]=1;
	f[1][4]=0;

	f[2][0]=3;
	f[2][1]=0;
	f[2][2]=2;
	f[2][3]=5;

	f[3][0]=3;
	f[3][1]=1;
	f[3][2]=4;
	f[3][3]=3;

	f[4][0]=4;
	f[4][1]=0;
	f[4][2]=1;
	f[4][3]=3;
	f[4][4]=2;

	f[5][0]=4;
	f[5][1]=2;
	f[5][2]=3;
	f[5][3]=4;
	f[5][4]=5;
	return(f);
    }





    public static Polyhedron P0(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointB(a);
	P.V[2]=pointD(a);
	P.V[3]=pointC(a);
	P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P1(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointB(a);
	P.V[1]=pointA(a);
	P.V[2]=pointF(a);
	P.V[3]=pointE(a);	
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P2(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointA(a);
	P.V[2]=pointK(a);
	P.V[3]=pointM(a);  
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P3(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointF(a);
	P.V[2]=pointK(a);
	P.V[3]=pointL(a);  
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P4(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointI(a);
	P.V[2]=pointC(a);
	P.V[3]=pointD(a);
	P.V[4]=pointH(a);	
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }

    public static Polyhedron P5(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointF(a);
	P.V[1]=pointH(a);
	P.V[2]=pointD(a);
	P.V[3]=pointC(a);
	P.V[4]=pointI(a);
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }

    public static Polyhedron P6(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointF(a);
	P.V[1]=pointI(a);
	P.V[2]=pointL(a);
	P.V[3]=pointK(a);
	P.V[4]=pointH(a);   
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }


    public static Polyhedron P7(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointH(a);
	P.V[2]=pointF(a);
	P.V[3]=pointE(a);
	P.V[4]=pointJ(a);   
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }


    public static Polyhedron P8(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointH(a);
	P.V[2]=pointF(a);
	P.V[3]=pointE(a);
	P.V[4]=pointJ(a);   
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }

    public static Polyhedron P9(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointH(a);
	P.V[2]=pointK(a);
	P.V[3]=pointM(a);
	P.V[4]=pointJ(a);   
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }

    public static Polyhedron P10(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointJ(a);
	P.V[2]=pointH(a);
	P.V[3]=pointO(a);
	P.V[4]=pointN(a);  
        P.facet=prismFacets();
	P.length=5;
	return(P);
    }



    public static Polyhedron P11(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointJ(a);
	P.V[1]=pointH(a);
	P.V[2]=pointM(a);
	P.V[3]=pointK(a);	
        P.V[4]=pointO(a);
	P.V[5]=pointN(a);

        P.facet=wedgeFacets();
	P.length=6;
	return(P);
    }

    public static Polyhedron P12(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointN(a);
	P.V[2]=pointO(a);
        P.V[3]=pointF(a);
	P.V[4]=pointE(a);

        P.facet=prismFacets();
	P.length=5;
	return(P);
    }

    public static Polyhedron P13(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointD(a);
	P.V[1]=pointF(a);
	P.V[2]=pointO(a);
        P.V[3]=pointH(a);

        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P14(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointO(a);
	P.V[1]=pointH(a);
	P.V[2]=pointD(a);
	P.V[3]=pointA(a);	
        P.V[4]=pointJ(a);
	P.V[5]=pointN(a);

        P.facet=wedgeFacets();
	P.length=6;
	return(P);
    }

    public static Polyhedron P15(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointF(a);
	P.V[1]=pointA(a);
	P.V[2]=pointI(a);
	P.V[3]=pointH(a);
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P16(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointH(a);
	P.V[2]=pointJ(a);
	P.V[3]=pointI(a);
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P17(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointO(a);
	P.V[1]=pointN(a);
	P.V[2]=pointF(a);
	P.V[3]=pointE(a);
	P.V[4]=pointM(a);
	P.V[5]=pointK(a);
        P.facet=wedgeFacets();
	P.length=6;
	return(P);
    }

    public static Polyhedron P18(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointO(a);
	P.V[1]=pointH(a);
	P.V[2]=pointF(a);
	P.V[3]=pointK(a);
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron P19(double[] a) {
	Polyhedron P=new Polyhedron();
	P.V[0]=pointA(a);
	P.V[1]=pointD(a);
	P.V[2]=pointH(a);
	P.V[3]=pointF(a);
        P.facet=tetraFacets();
	P.length=4;
	return(P);
    }

    public static Polyhedron PX(int k,double[] a) {
	Polyhedron P=PXRaw(k,a);
	return P.retract(a[3]);
    }

    public static Polyhedron PXRaw(int k,double[] a) {
	if(k==0) return(P0(a));
	if(k==1) return(P1(a));
	if(k==2) return(P2(a));
	if(k==3) return(P3(a));
	if(k==4) return(P4(a));
	if(k==5) return(P5(a));
	if(k==6) return(P6(a));
	if(k==7) return(P7(a));
	if(k==8) return(P8(a));
	if(k==9) return(P9(a));
	if(k==10) return(P10(a));
	if(k==11) return(P11(a));
	if(k==12) return(P12(a));
	if(k==13) return(P13(a));
	if(k==14) return(P14(a));
	if(k==15) return(P15(a));
	if(k==16) return(P16(a));
	if(k==17) return(P17(a));
	if(k==18) return(P18(a));;
	if(k==19) return(P19(a));
	return(null);
    }

}

